#!/usr/bin/ruby

require 'nkf'
require 'ProgramOpt'

option = "-w"
opts = ProgramOpt.new

begin
Dir.chdir(opts.current_dir)
rescue => ex
    print ProgramOpt::ErrorDirMessage
    print ex.message, "\n"
end

Dir.glob("*.emlx") { |name|
    plain = gif = jpeg = html = "-"

    begin    
        File.open(name) {|f|
            mail_flag = subject_flag = plain_flag = gif_flag = jpeg_flag = false
            subject = mail_adress = ""
            utf8_subject = utf8_from = utf8_name = ""

            begin
            f .each { |line|
                utf8_line = NKF::nkf(option, line)
 
                if /^Subject:(.*)/ =~ utf8_line
                    utf8_subject = $1
                end

                if /^From:\s*"(.*)"\s*<(.*)>/ =~ utf8_line
                    utf8_name = $1
                    utf8_from = $2
                elsif /^From:\s*(.*)\s*<(.*)>/ =~ utf8_line
                    utf8_name = $1
                    utf8_from = $2
                elsif /^From:\s*(.*)/ =~ utf8_line 
                    utf8_name = ""
                    utf8_from = $1
                end
 
                if /^----.*/ =~ line
                    plain_flag = false
                    gif_flag = false
                   jpeg_flag = false
                end

                if subject_flag
                    /.*<string>(.*)<\/string>.*/ =~ line
                   subject = $1
                    subject_flag = false
                end

                if mail_flag
                    if /.*<string>(.*)&lt;(.*)&gt.*<\/string>.*/ =~ line
                        if opts.programConfig[:f]
                            mail_adress = $2
                        elsif opts.programConfig[:n]
                           mail_adress = $1
                        else
                            mail_adress = $1 + "<" + $2 + ">"
                        end
                    elsif /.*<string>(.*)<\/string>.*/ =~ line
                        if opts.programConfig[:f]
                            mail_adress = $1
                        elsif opts.programConfig[:n]
                            mail_adress = ""
                        else
                            mail_adress = "<" + $1 + ">"
                        end
                    end
                      
                    mail_flag = false
                end
        
                if /.*<key>subject<\/key>/  =~ line
                    subject_flag = true
                end

                if /.*<key>sender<\/key>/  =~ line
                    mail_flag = true
                end

                if /^.*Content-Transfer-Encoding:\s*base64.*/ =~ line  
                    if plain_flag
                        plain = "p"
                        plain_flag = false
                    end
                    if gif_flag
                        gif = "g"
                        gif_flag = false
                    end
                    if jpeg_flag
                        jpeg = "j"
                        jpeg_flag = false
                    end
                end

                if /^.*Content-Type:\s*text\/plain.*/ =~ line
                    plain_flag = true
                end

                if /^.*Content-Type:\s*image\/gif.*/ =~ line
                    gif_flag = true
                end

                if /^.*Content-Type:\s*image\/jpeg.*/ =~ line
                    jpeg_flag = true
                end

                if /^.*Content-Type:\s*text\/html.*/ =~ line
                    html = "h"
                end

            }
        rescue => ex
#            print ex.message, "\n"
        end
            
        if opts.programConfig[:k]
            subject = utf8_subject
            if opts.programConfig[:f]
                mail_adress = utf8_from
            elsif opts.programConfig[:n]
                 mail_adress = utf8_name
            else
                mail_adress = utf8_name + "<" + utf8_from + ">"
            end
        end

        if opts.programConfig[:s]
            print sprintf("%s%s%s%s %s Subject:%s\n", html, plain, gif, jpeg, name, subject)        
        elsif opts.programConfig[:m] || opts.programConfig[:f] || opts.programConfig[:n] 
            print sprintf("%s%s%s%s %s From:%s\n", html, plain, gif, jpeg, name, mail_adress)        
        elsif opts.programConfig[:a]
            print sprintf("%s%s%s%s %s From:%s\n", html, plain, gif, jpeg, name, mail_adress)
            print sprintf("    %s Subject:%s\n", " "*name.size, subject)
        else
            print sprintf("%s%s%s%s %s Subject:%s\n", html, plain, gif, jpeg, name, subject)        
        end
    }
    rescue => ex
        print ex.message, "\n"
    end
}
