#!/usr/bin/ruby

require 'optparse'

=begin
    $TRASH_DIR A$INBOX_DIRA$OTHER_DIR ̊ɂpXɐݒ肵ĂB
=end

$TRASH_DIR = "/Users/Ȃ̃AJEg/Library/Mail/[AJEg/Deleted Messages.mbox/Messages"

$INBOX_DIR = "/Users/Ȃ̃AJEg/Library/Mail/[AJEg/INBOX.mbox/Messages"

$OTHER_DIR = "/Users/Ȃ̃AJEg/Library/Mail/Mailboxes/[{bNX.mbox/Messages"

class ProgramOpt
    attr_accessor :programConfig, :opts
    attr_accessor :current_dir, :original_dir
    attr_accessor :name
    
    ErrorDirMessage = "$TRASH_DIR, $INBOX_DIR, $OTHER_DIR in ProgramOpt.rb\n"

    def initialize
        @programConfig = Hash.new
        @opts = OptionParser.new

        @opts.on_tail("-t", "Trash Folder") { |v|
            @programConfig[:t] = true
        }

        @opts.on_tail("-i", "Inbox Folder") { |v|
            @programConfig[:i] = true
        }

        @opts.on_tail("-s", "(s)Print Subject") { |v|
            @programConfig[:s] = true
        }

        @opts.on_tail("-m", "(s)Print Mail Name, Mail Adress") { |v|
            @programConfig[:m] = true
        }

        @opts.on_tail("-a", "(s)Print Subject, Mail Name, Mail Adress") { |v|
            @programConfig[:a] = true
        }

        @opts.on_tail("-o", "Other Folder") { |v|
            @programConfig[:o] = true
        }

        @opts.on_tail("-f", "(s)Print Mail Adress") { |v|
            @programConfig[:f] = true
        }

        @opts.on("-n", "(s)Print Mail Name") { |v|
            @programConfig[:n] = true
        }

        @opts.on("-k", "(s)NKF Subject, Mail Name, Mail Adress") { |v|
            @programConfig[:k] = true
        }

        @opts.parse!(ARGV)

        @name = ARGV[0]

        @current_dir = @original_dir = Dir.pwd

        if @programConfig[:t] == true
            @current_dir = $TRASH_DIR
        elsif @programConfig[:i] == true
            @current_dir = $INBOX_DIR
        elsif @programConfig[:o] == true
            @current_dir = $OTHER_DIR
        end
    end
end


class StringBase64
    attr_accessor :name, :code64, :image_name
    attr_accessor :mode_reg

    def initialize(name, reg, image_name="plain.txt")   
        @name = name
        @code64 = String.new
        @code = String.new
        @mode_reg = reg
        @image_name = image_name
    end

    def base64

        plain_flag = false
        base64_flag = false

        File.open(@name) {|f|
            f.each { |line|

                if /^$/ =~line
                elsif base64_flag && /^.*Content-ID.*/ =~line
                elsif plain_flag && /^.*name="(.*)".*/ =~line
                    @image_name = $1
                elsif /^----.*/ =~line
                    base64_flag = false
                elsif base64_flag
                    @code64.concat(line)           
                elsif @mode_reg =~line
                    plain_flag = true
                    count = 0
                elsif plain_flag && /^.*Content-Transfer-Encoding:\s*base64.*/ =~line
                    plain_flag = false
                    base64_flag = true
                end
            }
        }

        array_line = @code64.unpack("m")
      
        return array_line
 
    end

end
